
//======================================================================
//Parameters

// Size of the sheet
const int Nx = 35;//16+1;
const int Ny = 2;//30+1;

// Dimentions for periodic or bent sheet
double r_out = 28; // outer radius
double r_in = 24; // Inner radius
// For Periodic
//double Theta_step = 2*3.141592653589793/Nx;
// For Curved Sheet
const double Theta_step = .25*2*3.141592653589793/Nx;

const int Constrict_mid = 14; // How many cells contrict around the middle
const int Constrict_side = (Nx - 1 - Constrict_mid)/2; // How many cells on the side

const int Constrict_start = Constrict_side; // Beggining of constriction around X
const int Constrict_end = Nx - 2 - Constrict_start; // end of contriction around X

const int y_start = 0;
const int y_stop = Ny - 2 - y_start;

const char b_record = '0';

//const double alpha = 0;//.10; // Apical
//const double beta = 0; // Basal
//const double gama = .1; // Side
//const double zeta = 0;

// Define strenghts of the potentials
const double K_volume = 100;
const double K_apical = 0.4;
const double K_basal = 0;
const double K_length = 2.0;
const double K_diagonal = 2.0;
const double K_yolk = 0;

// Define basal friction factor
const double Basal_friction = 0.9;

// New length for constriction
const double A_con_factor = 0.12;
const double KA_con_factor = 51.2/K_apical;

// Sigma for the Gaussian Distribution
const double KA_sigma = 5.0; // Sigma for the districution

// Dimentions for flat sheet, if used
double X_spacing = 1.0;
double Y_spacing = 1.0;
double Z_spacing = 4.0;

// This is for diffusive motion
double D_step = 0;
//======================================================================

