#include <iostream>
#include <fstream>
#include <math.h>
using namespace std;


#include "F_par.h"
#include "auxlrs.h"

int main() {
	
#include "a_par_0.h"
#include "b_par_0.h"
	
	//=====================================================================================================================================
	// Initialize variables
#include "create_variables_slave.h"
	//=====================================================================================================================================
	// Initialize data
#include "init.h"
	
	//=====================================================================================================================================
	// State what the slave id is for this slave
	const int SLAVE_ID = 4;
	const int INTERM_ID1 = 7;
	const int INTERM_ID2 = 4;
	
	//=====================================================================================================================================
	// Now run the slave time loop
	#include "time_loop_slave_4.h"
	
	
	for (i=0; i<Nc; i++) {
		
		for (k=0; k<4; k++) {
			AP[k][0] = Vx[C_apver[i][k]]; AP[k][1] = Vy[C_apver[i][k]]; AP[k][2] = Vz[C_apver[i][k]];
			BS[k][0] = Vx[C_bsver[i][k]]; BS[k][1] = Vy[C_bsver[i][k]]; BS[k][2] = Vz[C_bsver[i][k]];
		}
		
		A_0 = A_from_cell(AP, BS);
		B_0 = B_from_cell(AP, BS);
		V_0 = V_from_cell(AP, BS);
		L_0 = sqrt(pow(AP[0][0] - BS[0][0], 2) + pow(AP[0][1] - BS[0][1], 2) + pow(AP[0][2] - BS[0][2], 2));
		
		cout << "For cell " << i << " A = " << A_0 << " B_0 = " << B_0 << " V_0 = " << V_0 << " L_0 = " << L_0 << endl;
	}
	
	
	return 0;
}
