

//======================================================================
//Parameters

const char a_record = '0';

const double dx = .001;

const int T_end = 200000;
const int T_record = 2000;
const int T_display = 100;

int T_count_max;


double alpha = 0;
double alpha_init = 10;
double rho = .9;
double c = 0;

T_count_max = 1000;

// Size of the sheet
const int Nx = 54;
const int Ny = 2;

// Dimentions for flat sheet, if used
double X_spacing = 0.8;
double Y_spacing = 1.8;
double Z_spacing = 2.0;

// Sigma for the Gaussian Distribution
const double KA_sigma = 6.0;
const double KA_sigma_y = 1.0;// Sigma for the districution

const int Constrict_start = 20; // Beggining of constriction around X
const int Constrict_end = 32; // end of contriction around X

const double K_basal = 0;
const double K_basal_con = 0; // The value of K_basal in the constricting region
const double K_L_factor = 1.0;

const double KL_con_value = 0;

const double K_volume = 250.0;


// Dimentions for periodic or bent sheet
double r_out = 12.0; // outer radius
double r_mid = r_out - Z_spacing; // outer radius
double r_in = r_out - 2.0*Z_spacing; // Inner radius

// For Curved Sheet
const double Theta_size = Nx*X_spacing/r_out;
const double Theta_step = Theta_size/(Nx-1);

// Flags to define the conditions of the simulation
const int Sheet_condition = 1; // 1 for bent sheet, 2 for flat sheet

const int fixed_y = 1; // flag for fixing y (1 fixed, 0 not fixed)
const int fixed_first_last_cell_z = 0;// flag for fixing first 2 and last 2 cells along z
const int fixed_first_last_vert_xyz = 1; // flag for fixing the first/last verts along xyz 
const int fixed_top = 1; // flag for introducingthe apical membrane

const int yolk_present = 1; //  flag for the yolk
const int plane_constraint_present = 1; // flag that the plane is contraining

const int neighbor_apical_active = 0; // flag for having the neighboring cells also constrict
const int neighbor_basal_strong = 0; // flag for having the neighboring cells have strong base

const int neighbor_cell_N = 2; // Number of neighbor cells

const int gaussian_KA_flag = 1; // flag for having a gaussian distribution of 
const int gaussian_cut = 0; // flag for having the gaussian distibution for only the constricting cells

const int midline_wall_flag = 0; // flag for having the midline act like a wall

const int record_init = 0; // flag for recording the initial positions for further use

const int Percent_stop_flag = 0;
const double Percent_stop = .000001;

//======================================================================




