function Plot_Vert(Vx, Vy, Vz, nx, ny, x_start, x_stop, sel)

x_start = x_start + 1;
x_stop = x_stop + 2;
X = reshape(Vx, nx, ny, 2);
Y = reshape(Vy, nx, ny, 2);
Z = reshape(Vz, nx, ny, 2);

X_tmp = reshape(X(x_start:x_stop, :, 1), (x_stop + 1 - x_start)*2, 1, 1);
Y_tmp = reshape(Y(x_start:x_stop, :, 1), (x_stop + 1 - x_start)*2, 1, 1);
Z_tmp = reshape(Z(x_start:x_stop, :, 1), (x_stop + 1 - x_start)*2, 1, 1);

scatter3(Vx(sel), Vy(sel), Vz(sel), 100, 'r', 'filled');
scatter3(X_tmp, Y_tmp, Z_tmp, 30, 'g', 'filled');
scatter3(Vx, Vy, Vz, 20, 'r', 'filled');
%scatter3(Vx(1:(end/2)), Vy(1:(end/2)), Vz(1:(end/2)), 30, 'r', 'filled');
%scatter3(Vx((end/2+1):end), Vy((end/2+1):end), Vz((end/2+1):end), 30, 'b', 'filled');

for i=1:nx,
    for j=1:ny,
        plot3([X(i, j, 1) X(i, j, 2)], [Y(i, j, 1) Y(i, j, 2)], [Z(i, j, 1) Z(i, j, 2)], 'k', 'linewidth', 3);
    end
end


for i=1:(nx-1),
    for j=1:(ny-1),
        fill3([X(i, j, 1), X(i, j+1, 1), X(i+1, j+1, 1), X(i+1, j, 1)], [Y(i, j, 1), Y(i, j+1, 1), Y(i+1, j+1, 1), Y(i+1, j, 1)], [Z(i, j, 1), Z(i, j+1, 1), Z(i+1, j+1, 1), Z(i+1, j, 1)], 'r');
        fill3([X(i, j, 2), X(i, j+1, 2), X(i+1, j+1, 2), X(i+1, j, 2)], [Y(i, j, 2), Y(i, j+1, 2), Y(i+1, j+1, 2), Y(i+1, j, 2)], [Z(i, j, 2), Z(i, j+1, 2), Z(i+1, j+1, 2), Z(i+1, j, 2)], 'b');
    end
end



end

