function E = CALC_ENERGY(Ax, Ay, Bx, By, KV, Vo, KL, Lo)

E = sum(KL*(sqrt((Ax - Bx).^2 + (Ay - By).^2) - Lo).^2);

V1x = Ax(1:(end-1)) - Ax(2:end); V1y = Ay(1:(end-1)) - Ay(2:end);
V2x = Ax(1:(end-1)) - Bx(2:end); V2y = Ay(1:(end-1)) - By(2:end);
V3x = Ax(1:(end-1)) - Bx(1:(end-1)); V3y = Ay(1:(end-1)) - By(1:(end-1));

E = E + sum(KV*(abs(V1x.*V2y - V1y.*V2x)/2 + abs(V2x.*V3y - V2y.*V3x)/2 - Vo).^2);


end