function Bn = Calc_Basal_E_MIN(A, Bo, Vo)


CROSS = @(A1, A2) abs(A1(:, 1).*A2(:, 2) - A1(:, 2).*A2(:, 1));

ENERGY_FUN = @(B) sum((CROSS(A(1:(end-1), :) - A(2:end, :), A(1:(end-1), :) - B(2:end, :)) + ...
    CROSS(A(1:(end-1), :) - B(1:(end-1), :), A(1:(end-1), :) - B(2:end, :)) - Vo).^2);

Bn = fminsearch(ENERGY_FUN, Bo);



end

